/**************************************************************

konve.c )(C-Munipack project)
Copyright )(C) 2003 David Motl, dmotl@volny.cz

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or )(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

**************************************************************/

#ifndef CCDFILE_H
#define CCDFILE_H

#include "context.h"
#include "cmpack_ccdfile.h"
#include "cmpack_console.h"

typedef void *tHandle;

/* Copy entire frame */
void ccd_clear_header(CmpackCcdFile *fc);

/* Copy entire frame */
int ccd_copy(CmpackCcdFile *source, CmpackCcdFile *target, CmpackBitpix bitpix, 
		int flipx, int flipy, const CmpackBorder *border, CmpackConsole *con);

/* Copy header */
int ccd_copy_header(CmpackCcdFile *source, CmpackCcdFile *target);

/* Set frame size in pixels */
int ccd_prepare(CmpackCcdFile *fc, int width, int height, CmpackBitpix bitpix);

/* Set image data */
int ccd_write_image(CmpackCcdFile *ctx, CmpackBitpix bitpix, const void *buf);

/* Append text to the history */
int ccd_write_history(CmpackCcdFile *ctx, const char *text);

/* Set date and time of observation */
int ccd_set_datetime(CmpackCcdFile *fc, const CmpackDateTime *dt);

/* Set exposure duration */
void ccd_set_exptime(CmpackCcdFile *fc, double exptime);

/* Set CCD temperature */
void ccd_set_ccdtemp(CmpackCcdFile *fc, double ccdtemp);

/* Set object's designation */
void ccd_set_object(CmpackCcdFile *fc, const char *name);

/* Set number of frames combined together */
void ccd_set_frames(CmpackCcdFile *fc, int frames);

/* Set a logical value to a file header */
void ccd_set_bool(CmpackCcdFile *fc, const char *key, int val, const char *comment);

/* Set a real value to a file header */
void ccd_set_dbl(CmpackCcdFile *fc, const char *key, double val, int prec, const char *comment);

/* Write package name and version to file header */
void ccd_set_origin(CmpackCcdFile *fc);

/* Write date of creation */
void ccd_set_pcdate(CmpackCcdFile *fc);

#endif
