/**************************************************************

file.h (C-Munipack project)
Photometry file private header file
Copyright (C) 2003 David Motl, dmotl@volny.cz

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

**************************************************************/

#ifndef PHOT_FILE_H
#define PHOT_FILE_H

#include "context.h"
#include "phthead.h"
#include "phtaper.h"
#include "phtstars.h"

/* Photometry file context */
struct _CmpackPhtFile 
{
	CmpackContext gc;		/**< Global context */
	CmpackHeader hd;		/**< Table of sections (file header) */
	CmpackAperTab ap;		/**< Table of apertures */
	CmpackStarTab st;		/**< Table of stars (measurements) */
};

#endif
