/**************************************************************

applyto.cpp (C-Munipack project)
"Apply to" widget
Copyright (C) 2008 David Motl, dmotl@volny.cz

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

**************************************************************/

#include <stdlib.h>
#include <glib.h>

#include "applyto.h"
#include "main.h"

CApplyTo::CApplyTo()
{
	m_Widget = m_AllBtn = m_SelBtn = NULL;
}

CApplyTo::~CApplyTo()
{
}

void CApplyTo::Create(const gchar *caption)
{
	GtkWidget *vbox;

	// Frame
	m_Widget = gtk_frame_new(caption);

	// Frame layout
	vbox = gtk_vbox_new(FALSE, 4);
	gtk_container_add(GTK_CONTAINER(m_Widget), vbox);
	gtk_container_set_border_width(GTK_CONTAINER(vbox), 4);
	gtk_widget_show(vbox);

	// Options
	m_AllBtn = gtk_radio_button_new_with_label(NULL, "all files in current project");
	gtk_box_pack_start(GTK_BOX(vbox), m_AllBtn, TRUE, TRUE, 0);
	gtk_widget_show(m_AllBtn);

	GSList *group = gtk_radio_button_get_group(GTK_RADIO_BUTTON(m_AllBtn));
	m_SelBtn = gtk_radio_button_new_with_label(group, "selected files only");
	gtk_box_pack_start(GTK_BOX(vbox), m_SelBtn, TRUE, TRUE, 0);
	gtk_widget_show(m_SelBtn);

	// Default state
	GtkTreeSelection *pSel = Global.pMainWnd->GetSelection();
	if (gtk_tree_selection_count_selected_rows(pSel)>1) 
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(m_SelBtn), true);
	else
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(m_AllBtn), true);

	gtk_widget_show_all(m_Widget);
}

bool CApplyTo::GetState(void)
{
	return gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(m_AllBtn))!=0;
}
