/**************************************************************

config_dlg.h (C-Munipack project)
Configuration dialog
Copyright (C) 2008 David Motl, dmotl@volny.cz

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

**************************************************************/

#ifndef CMPACK_CONFIG_DLG_H
#define CMPACK_CONFIG_DLG_H

#include <gtk/gtk.h>

class CConfigDlg
{
public:
	CConfigDlg(GtkWindow *pParent);
	~CConfigDlg();

	void Execute();
private:
	GtkWidget		*m_pDlg;
	GtkTreeStore	*m_TreeStore;
	GtkWidget		*m_TreeView, *m_ScrWnd, *m_Notebook;
	int				m_TabCount;
	struct tTabData *m_Tabs;
	int				m_Section;
	bool			m_Updating;

	void LoadConfig(void);
	void SaveConfig(void);

	void MakeData(void);
	void MakeTreeView(void);
	void MakeNotebook(void);
	void MakeSection(GtkTreeStore *tree, const struct tSection *list, 
		int parent_id, GtkTreeIter *parent);
	void MakeControl(const struct tParameter *info, GtkWidget ***widgets,
		int *nwidgets);

	void SetCategory(int section);
	void OnSelectionChanged(void);
	int SectionToPage(int section);
	bool TabChanging(int section);
	void TabChange(int section);
	void OnSetDefaultsClicked(GtkButton *pButton);
	void OnFileButtonClicked(GtkButton *pButton);

	void LoadData(struct tParData *pData);
	void SaveData(const struct tParData *pData);
	void SetData(const struct tParData *pData);
	void SetDefault(const struct tParData *pData);
	void GetData(struct tParData *pData);
	void ChooseFile(struct tParData *pData);

	static gint selection_changed(GtkTreeSelection *widget, CConfigDlg *data);
	static void setdefaults_clicked(GtkButton *widget, CConfigDlg *user_data);
	static void filebutton_clicked(GtkButton *widget, CConfigDlg *user_data);
};

#endif
