/**************************************************************

deviations_dlg.h (C-Munipack project)
The 'Plot deviations' dialog
Copyright (C) 2008 David Motl, dmotl@volny.cz

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

**************************************************************/

#ifndef CMPACK_DEVIATIONS_DLG_H
#define CMPACK_DEVIATIONS_DLG_H

#include <gtk/gtk.h>
#include <cmunipack.h>

#include "graph.h"
#include "graph_data.h"

class CDeviationsDlg
{
public:
	CDeviationsDlg(GtkWindow *pParent);
	~CDeviationsDlg();

	void Execute();
private:
	GtkWidget		*m_pDlg, *m_DataView;
	GtkListStore	*m_DataList;
	CGraph			m_Graph;
	CGraphData		m_Data;
	int				m_InFiles, m_OutFiles, m_Column;
	GSList			*m_FileList;
	CmpackTable		*m_Table;

	int ProcessFiles(class CProgressDlg *sender);
	void SetData(int column);
	void OnSelectionChanged(GtkTreeSelection *selection);
	bool OnCloseQuery(gint response_id);
	void SaveData(void);

	static gboolean foreach_all_files(GtkTreeModel *model, GtkTreePath *path, GtkTreeIter *iter, GSList **data);
	static void selection_changed(GtkTreeSelection *widget, CDeviationsDlg *pMe);
	static void response_dialog(GtkDialog *pDlg, gint response_id, CDeviationsDlg *pMe);
	static int ExecuteProc(class CProgressDlg *sender, void *user_data);
	static void col_name_free(char *str, void *data);
};

#endif
