/**************************************************************

newfiles_dlg.h (C-Munipack project)
The 'Process new files' dialog
Copyright (C) 2008 David Motl, dmotl@volny.cz

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

**************************************************************/

#ifndef CMPACK_NEWFILES_DLG_H
#define CMPACK_NEWFILES_DLG_H

#include <gtk/gtk.h>
#include <cmunipack.h>

class CNewFilesDlg
{
public:
	CNewFilesDlg(GtkWindow *pParent);
	~CNewFilesDlg();

	void Execute();
private:
	GtkWidget	*m_pDlg, *m_AllBtn, *m_FilesBtn, *m_Folder;
	GtkWidget	*m_FilterCheck, *m_FilterEdit, *m_NameCheck, *m_NameEdit;
	GtkWidget	*m_ObjectCheck, *m_ObjectEdit, *m_FolderLabel, *m_ProcLabel;
	GtkWidget	*m_SubDirs;
	int			m_InFiles, m_OutFiles;
	GList		*m_FileList;

	static gboolean foreach_all_files(GtkTreeModel *model, GtkTreePath *path, GtkTreeIter *iter, gpointer data);
	static void button_toggled(GtkToggleButton *widget, CNewFilesDlg *user_data);

	static int ExecuteProc(class CProgressDlg *sender, void *user_data);

	GList *PrepareFolder(GList *list, const char *dirpath, bool recursive,
		GtkFileFilter *filenames, char **filters, char **objects);
	bool TestString(char **list, const char *str);
	bool CheckFileName(const char *fullpath, GtkFileFilter *filenames);
	bool CheckFileData(const struct tFileData *data, char **filters, char **objects);
	GtkFileFilter *MakeFileFilter(const char *text);

	void UpdateControls(void);
	void OnButtonToggled(GtkToggleButton *widget);

	int ProcessFiles(class CProgressDlg *sender);
};

#endif
