/**************************************************************

object_dlg.h (C-Munipack project)
The 'Enter object coordinates' dialog
Copyright (C) 2009 David Motl, dmotl@volny.cz

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

**************************************************************/

#ifndef CMPACK_OBJECT_DLG_H
#define CMPACK_OBJECT_DLG_H

#include <gtk/gtk.h>

class CObjectDlg
{
public:
	CObjectDlg(GtkWindow *pParent);
	~CObjectDlg();

	bool Execute();

private:
	// Selection modes
	enum tSelectMode
	{
		REFERENCE_FRAME,
		MANUAL_ENTRY,
		CATALOGUE_FILE
	};

	GtkWidget		*m_pDlg, *m_Select, *m_RefBtn, *m_ManBtn, *m_CatBtn;
	GtkWidget		*m_AutoName, *m_AutoRA, *m_AutoDec, *m_AutoBox;
	GtkWidget		*m_EntryName, *m_EntryRA, *m_EntryDec, *m_EntryBox;
	GtkWidget		*m_SearchBox, *m_FindText, *m_FindBtn, *m_SearchView;
	tSelectMode		m_SelectMode;
	int				m_SortColumn, m_Counter;
	GSList			*m_Columns;
	GtkListStore	*m_SearchRes;

	void SetSelectMode(tSelectMode mode);
	void SetSortColumn(int column);
	void FindObjects(void);

	bool OnResponseDialog(gint response_id);
	void OnColumnClicked(GtkTreeViewColumn *pCol);
	void OnButtonClicked(GtkWidget *pBtn);

	static void response_dialog(GtkDialog *pDlg, gint response_id, CObjectDlg *pMe);
	static void column_clicked(GtkTreeViewColumn *treeviewcolumn, CObjectDlg *pDlg);
	static void button_clicked(GtkWidget *pButton, CObjectDlg *pDlg);
	static void AddToList(const char *objname, const char *ra, const char *dec,
		const char *catalogue, const char *comment, CObjectDlg *data);
};

#endif
